/*Kuki Szabolcs, cl. XII -a, Colegiul "Mihai Eminescu", Satu Mare, Judetul Satu Mare*/
/*			 T R I U N G H I U R I
			     (25 puncte)

	Fiind date n (3<= n <=100) puncte in plan, sa se determine trei
dintre acestea, care formeaza un triunghi ce contine numarul maxim de
puncte posibil, dintre cele ramase.

	Citirea se face din fisierul "trdate" avand structura:
n
x1 y1
x2 y2
.....
xn yn

unde n este numarul de puncte, iar xi, yi coordonatele punctelor.

	Solutia se scrie in fisierul "trsol" avand structura:
a b
c d
e f
p

unde (a,b), (c,d), (e,f) sunt coordonatele varfurilor triunghiului,
iar p numarul de puncte aflate in interiorul triunghiului. Se considera
ca un punct aflat pe o latura triunghiului este in interior.


Timp maxim de executie 30 secunde pentru un 386 la 33MHz

*/

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#define NRPCT 100
#define NRMAXDBL (double)9999999

int pct[NRPCT][2];
int pf1, pf2, pf3;
int nrpct, nrmaxin=0, nrinc=0;
int p12, p23, p31;
double m12, m23, m31;
double a12, b12, c12;
double a23, b23, c23;
double a31, b31, c31;

///////////////////////////////////////////////////
int sort_function( const void *a, const void *b)
{
   return( *(int *)a - *(int *)b );
}


////Introducerea_datelor///////////////////////////////////////////////
void Introducerea_datelor(void)
{
FILE *filehi;
int z;
filehi=fopen("trdate", "rt");
fscanf(filehi, "%d", &nrpct);

for(z=0; z<nrpct; z++)
 {
 fscanf(filehi, "%d", &pct[z][0]);
 fscanf(filehi, "%d", &pct[z][1]);
 }
fclose(filehi);

clrscr();
 printf("nrpct %d\n", nrpct);
for(z=0; z<nrpct; z++)
 printf("%d %d\n", pct[z][0], pct[z][1]);

qsort(pct, nrpct, sizeof(pct[0]), sort_function);


printf("\nnrpct %d\n", nrpct);
for(z=0; z<nrpct; z++)
 printf("%d %d\n", pct[z][0], pct[z][1]);

//getch();
}  //end Introducerea_datelor

////Colineare//////////////////////////////////////////////////////
char Colineare(int p1, int p2, int p3)
{
char ret=0;
if (pct[p1][0]==pct[p2][0])
	{
	 if (pct[p2][0]==pct[p3][0]) return 1;
				else return 0;
	}
			else
	{
	m12=(double)(pct[p1][1]-pct[p2][1]) / (double)(pct[p1][0]-pct[p2][0]);
	if (((-1)*m12*pct[p3][0] + pct[p3][1] + m12*pct[p1][0]-pct[p1][1])==0) ret=1;
	}
return ret;
}

///Put_sol///////////////////////////////////////////////////////////////
void Put_sol(void)
{
FILE *fileho;
fileho=fopen("trsol", "w+");
fprintf(fileho, "%d %d\n", pct[pf1][0], pct[pf1][1]);
fprintf(fileho, "%d %d\n", pct[pf2][0], pct[pf2][1]);
fprintf(fileho, "%d %d\n", pct[pf3][0], pct[pf3][1]);
fprintf(fileho, "%d\n", nrmaxin);
fclose(fileho);
}

////main///////////////////////////////////////////////////////////////
void main(void)
{
int z1, z2, z3, z4;
int rett;
Introducerea_datelor();
for(z1=0; z1<nrpct-2; z1++)
 for(z2=nrpct-1; z2>z1; z2--)
  for(z3=z1+1; z3<z2; z3++)
if (Colineare(z1, z2, z3)==0 && (z2-z1+1)>nrmaxin)
{
if (pct[z1][0]==pct[z2][0]) m12=NRMAXDBL;
			else m12=(double)(pct[z1][1]-pct[z2][1])/(double)(pct[z1][0]-pct[z2][0]);
if (pct[z3][0]==pct[z1][0]) m31=NRMAXDBL;
			else m31=(double)(pct[z3][1]-pct[z1][1])/(double)(pct[z3][0]-pct[z1][0]);
if (pct[z2][0]==pct[z3][0]) m23=NRMAXDBL;
			else m23=(double)(pct[z2][1]-pct[z3][1])/(double)(pct[z2][0]-pct[z3][0]);
nrinc=2;  //se refera la z1, z2;
a12=-m12, b12=1, c12=m12*pct[z1][0] - pct[z1][1]; if ((a12*pct[z3][0]+b12*pct[z3][1]+c12)<=0) p12=1; else p12=0;
a31=-m31, b31=1, c31=m31*pct[z3][0] - pct[z3][1]; if ((a31*pct[z2][0]+b31*pct[z2][1]+c31)<=0) p31=1; else p31=0;
a23=-m23, b23=1, c23=m23*pct[z2][0] - pct[z2][1]; if ((a23*pct[z1][0]+b23*pct[z1][1]+c23)<=0) p23=1; else p23=0;
for(z4=z1+1; z4<z2; z4++)
{
rett=1;  //inclus
if (!(((a12*pct[z4][0]+b12*pct[z4][1]+c12)<=0 && p12==1) || ((a12*pct[z4][0]+b12*pct[z4][1]+c12)>=0 && p12==0))) rett=0;
if (!(((a31*pct[z4][0]+b31*pct[z4][1]+c31)<=0 && p31==1) || ((a31*pct[z4][0]+b31*pct[z4][1]+c31)>=0 && p31==0))) rett=0;
if (!(((a23*pct[z4][0]+b23*pct[z4][1]+c23)<=0 && p23==1) || ((a23*pct[z4][0]+b23*pct[z4][1]+c23)>=0 && p23==0))) rett=0;
if (rett) nrinc++;
} //end for z4
if (nrinc>nrmaxin) nrmaxin=nrinc, pf1=z1, pf2=z2, pf3=z3;
} //end for z1, z2, z3
nrmaxin++;
Put_sol();
}  //end main
