/*Kuki Szabolcs, cl. XII, Colegiul "Mihai Eminescu", Satu Mare, Judetul Satu Mare*/
/*Problema 1: Impaturirea hartilor (45 puncte)

    O harta strategica este reprezentata ca o matrice cu n linii si m
coloane (1<=n , m<=100) fiecare componenta a matricii continand cota zonei
de teren corespunzatoare exprimata in metri de la nivelul marii, cota fiind
un numar natural.
	Determinati o modalitate de a impaturi harta astfel incat deasupra
sa se gaseasca o zona de arie maxima avand aceeasi cota.
	Plierea hartii se poate face doar orizontal si vertical (deci pe
directii paralele cu laturile hartiei) si numai cu doua parti egale (deci
daca o dimensiune a hartiei este impara, plierea de-a lungul laturii respective
nu este posibila).
	Pe ecran se va afisa aria zonei astfel determinate, cota
corespunzatoare, precum si codificarea sirului de plieri efectuate, folosind
urmatoarea conventie: se precizeaza mai intai directia
(H-orizontal; V-vertical) ,
apoi pozitia de la care se face plierea, apoi modul de pliere
(L-partea stanga deasupra; R-partea dreapta deasupra; U-partea de sus deasupra;
 D-partea de jos deasupra),
doua plieri consecutive fiind separate prin spatiu. Daca problema nu are
solutie se va afisa mesajul "Ghinion".

RESTRICTII DE INTRARE/IESIRE:
   Numele fisierului se va citi dela tastatura. Fisierul de intrare
contine pe prima linie n si m , dimensiunile hartiei ,
separate printr-un spatiu , iar pe urmatoarele n linii cate m
numere naturale care reprezinta cotele .
   Fisierul de iesire se va numi harta.out si va contine :
   pe prima linie mesajul "Aria maxima" urmat de valoarea maxima a zonei de teren determinate
   pe a doua linie mesajul "Cota" urmat de valoarea cotei comune zonei determinate
   pe a treia linie codificarea sirului de plieri

sau

   mesajul "Ghinion", daca problema nu are solutie.

   Exemplu:

Pentru fisierul de intrare :

     3 4
     1 1 1 1
     2 2 2 2
     2 2 2 2

Fisierul de iesire va contine mesajul "Ghinion"

Pentru fisierul de intrare :

     4 4
     1 1 1 1
     2 1 3 4
     1 2 3 4
     2 2 2 2

Fisierul de iesire poate fi :

  Aria maxima 4
  Cota 1               1 1 1 1
  H2U H1U              2 1 3 4

sau

  Aria maxima 4
  Cota 2
  H3D H4D


   Atentie ! Daca exista mai multe solutii se va afisa una singura !

Timp de executie 30 sec/test.
*/

//////SOURCE/////SOURCE////////SOURCE///////////SOURCE////////SOURCE//////////
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#define NRMAXLAT 100
#define NRMAXPLIERI 15

int tabla[NRMAXLAT][NRMAXLAT];
char pliere[NRMAXPLIERI][2],
//1 & pliere[pl][0]  true vertical false orizontal,
//2& true U false D, 2 & true L false R
     n, m;
int nrgc=NRMAXPLIERI;
int ariamax=0;

/////////////////////////////////////////////////////////////////////////////
void Introducerea_datelor_de_intrare(void)
{
int z1, z2;
char sir1[100];
FILE *filehi;
clrscr();
printf("Introduceti numele fisierului de intrare, (eventual calea):");
scanf("%s", sir1);
if ((filehi=fopen(sir1, "r"))==NULL)
	{
	 printf("\n\nFisier inaccesibil! (probabil nu exista.)\n\n\n\n				Program aborted\n");
	 exit(1);
	}

fscanf(filehi, "%d %d", &n, &m); //n - y, m - x
for(z1=0; z1<n; z1++)
 for(z2=0; z2<m; z2++)
  fscanf(filehi, "%d", &tabla[z1][z2]);
fclose(filehi);
}

/////////////////////////////////////////////////////////////////////////////
int Verifica_solutia(int y0, int x0, int y1, int x1)
{
int ret=1;
int z1, z2, cotaref;
cotaref=tabla[y0-1][x0-1];
for(z1=y0-1; z1<y1 && ret; z1++)
 for(z2=x0-1; z2<x1 && ret; z2++)
  if(tabla[z1][z2]!=cotaref) ret=0;
if (ret && (ariamax<((y1-y0+1)*(x1-x0+1)))) ariamax=(y1-y0+1)*(x1-x0+1);
			else ret=0;
return ret;
}

/////////////////////////////////////////////////////////////////////////////
void Pune_solutia(int nrsol, int cota)
{
FILE *fileho;
clrscr();
if (ariamax==0)
 {
if ((fileho=fopen("harta.out", "w"))==NULL)
		{
		printf("\n\nNu se poate crea fisierul harta.out.\n\n 		3 sugestii:\n 1. Fisier setat READ ONLY\n 2. Fisierul este deschis si folosit de catre un alt program\n 3. Disk full.\n\n\n			Pana atunci: program aborted!\n");
		getch();
		exit(1);
		}
fprintf(fileho, "Ghinion");
 }
else
{
int z;
nrgc=nrsol;
/*printf("Aria maxima %d\n", ariamax);
printf("Cota %d\n", cota);
for(z=0; z<nrgc; z++)
 {
 if ((pliere[z][0] & 1 ) == 0)  //orizontala
 {
  printf("H%d", pliere[z][1]);
   if ((pliere[z][0] & 2)==2) printf("U ");
			else printf("D ");
 }
 else  //verticala
  {
   printf("V%d", pliere[z][1]);
  if ((pliere[z][0] & 2)==2) printf("R ");
			else printf("L ");
  }

 }   //end for
*/
if ((fileho=fopen("harta.out", "w"))==NULL)
		{
		printf("\n\nNu se poate crea fisierul harta.out.\n\n 		3 sugestii:\n 1. Fisier setat READ ONLY\n 2. Fisierul este deschis si folosit de catre un alt program\n 3. Disk full.\n\n\n			Pana atunci: program aborted!\n");
		getch();
		exit(1);
		}

fprintf(fileho, "Aria maxima %d\n", ariamax);
fprintf(fileho, "Cota %d\n", cota);
for(z=0; z<nrgc; z++)
 {
 if ((pliere[z][0] & 1 ) == 0)
 {
  fprintf(fileho, "H%d", pliere[z][1]);
   if ((pliere[z][0] & 2)==2) fprintf(fileho, "U ");
			else fprintf(fileho, "D ");
 }
 else
  {
   fprintf(fileho, "V%d", pliere[z][1]);
  if ((pliere[z][0] & 2)==2) fprintf(fileho, "L ");
			else fprintf(fileho, "R ");
  }
 }   //end for
} //end else ariamax==0
fclose(fileho);
}  //end Pune_sol

/////////////////////////////////////////////////////////////////////////////
void Impaturiri(char hv, char ld, char y0, char x0, char y1, char x1, int level)
{
if ((y1-y0+1)*(x1-x0+1)>ariamax)
{
pliere[level-1][0]=0 | hv, pliere[level-1][0]=pliere[level-1][0] | ld;
if (hv)  //verticala
{ if (ld)
  pliere[level-1][1]=x1;  //partea dreapta ramane daca ld=2
 else
  pliere[level-1][1]=x0;   //partea dreapta se duce jos daca ld=0
}
else    //orizontala
 if (ld)
  pliere[level-1][1]=y1;  //partea de sus daca este adevarata
 else
  pliere[level-1][1]=y0;  //partea de jos daca ld=0

if (Verifica_solutia(y0, x0, y1, x1)) Pune_solutia(level, tabla[y0-1][x0-1]);
else
{
if ((y1-y0+1)%2==0 && ariamax<(y1-y0+1)*(x1-x0+1))
	{
	Impaturiri(0, 2, y0, x0, (y1+y0-1)/2, x1, level+1);  //0 pliere pe orizontala
	Impaturiri(0, 0, (y1+y0-1)/2+1, x0, y1, x1, level+1);
	}

if ((x1-x0+1)%2==0 && ariamax<(y1-y0+1)*(x1-x0+1))
	{
	Impaturiri(1, 2, y0, x0, y1, (x1+x0-1)/2, level+1);
	Impaturiri(1, 0, y0, (x1+x0-1)/2+1, y1, x1, level+1);
	}
} //end else
}  //end if nrcg>level
}  //end Impaturiri


/////////////////////////////////////////////////////////////////////////////
void main(void)
{
Introducerea_datelor_de_intrare(); //introduce n,m si tabla, respectiv, tablac
if (Verifica_solutia(1, 1, n, m)) Pune_solutia(0, tabla[0][0]);
else
{
if (n%2==0 && (ariamax<(m*n)))
	{
	Impaturiri(0, 2, 1, 1, n/2, m, 1);  //0 pliere pe orizontala
	Impaturiri(0, 0, n/2+1, 1, n, m, 1);
	}

if (m%2==0 && (ariamax<(m*n)))
	{
	Impaturiri(1, 2, 1, 1, n, m/2, 1);
	Impaturiri(1, 0, 1, m/2+1, n, m, 1);
	}

}  // end if else
if (ariamax==0) Pune_solutia(0, 0);
printf("\nDone.\n");
getch();
}  //end main
