/*Kuki Szabolcs, cl. XII -a, Colegiul "Mihai Eminescu", Satu Mare, Judetul Satu Mare*/
/*				PERECHI
			      (45 puncte)

    Sa se determine toate perechile de numere naturale (a, b) pentru care:

	q * q + r = n

unde q si r sunt respectiv catul si restul impartirii lui a * a + b * b la
a + b.

	Fisierul de intrare "pin" va avea pe fiecare linie cate o valoare
<= 10.000 corespunzatoare unui "n".

	Fisierul de iesire "prez" va avea structura:

n                  numarul "n" citit din fisierul "pin"
a1 b1
a2 b2
.....              perechile de numere naturale cerute
ai bi
t                  numarul perechilor gasite pentru un "n" citit

Observatie:        in cazul in care pentru un "n" citit nu exista nici o
^^^^^^^^^^^        pereche de numere (a, b) se va scrie in fisierul "prez",
		   mesajul "nu exista perechi (a, b)"


      Timp de executie 30 secunde/test (586 la 133MHz)

					    prof. Maria si Adrian Nita
					     Liceul "Emanuil Gojdu"
						     Oradea
*/
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define NMAXN 10000

FILE *filehi, *fileho;
int n;
typedef long int LI;
LI a, b, q, r, counts;
LI limita, maxdif=-100;

/////////////////////////////////////////////////////////////////////////////
void Init()
{
clrscr();
if ((filehi=fopen("pin9", "rb"))==NULL)
	{
	 printf("Eroare la accesarea fisierului PIN. (verificati existenta acestuia)\n\n\n\n\n						Program aborted.\n");
	 getch();
	 exit(1);
	}

if ((fileho=fopen("prez", "w"))==NULL)
	{
	 printf("Eroare la crearea fisierului PREZ. \n(incercati sa-l stergeti, verificati daca mai este loc pe HARDDISK \n si rulati din nou programul.\n\n\n\n\n					Program aborted.\n");
	 getch();
	 exit(1);
	}
}

/////////////////////////////////////////////////////////////////////////////
char Date_de_intrare(void)
{
char ret;
ret=fscanf(filehi, "%d", &n);
counts=0;
if (ret>0) return ret;
	else return 0;
}

/////////////////////////////////////////////////////////////////////////////
void Close(void)
{
fclose(filehi);
fclose(fileho);
printf("Done.\n");
}

/////////////////////////////////////////////////////////////////////////////
LI Calc(LI b)
{
 LI ret= b*b + a*a + r - q*b  - q*a;
 return ret;
}

/////////////////////////////////////////////////////////////////////////////
LI Calcpb(LI b)
{
return (a*a+b*b)/(a+b);
}

/////////////////////////////////////////////////////////////////////////////
void Cauta_solutiile()
{
if (n>0)
{
limita=(LI)sqrt(n);
for(q=1; q<=limita; q++)
 {
  r=n-q*q;
  for(a=0; a<=2*q; a++)
   for(b=a; b<=2*q; b++)
       if ((a+b)>0 && ((LI)(a*a+b*b)/(LI)(a+b))==q && (q*(b+a) + r)==(a*a+b*b) )
		{
//		  if ((b-q)>maxdif) maxdif=b-q;
//		  printf("%ld %ld\n", a, b);
//		  fprintf(fileho, "q:%ld r:%ld ", q, r);
		  fprintf(fileho, "%ld %ld\n", a, b);
		  counts+=2;
		  if (a!=b)
			fprintf(fileho, "%ld %ld\n", b, a);
		      else counts--;
		}

 }  //end for q=1 -> limita=sqrt(n)
} //end if n>0
}

/////////////////////////////////////////////////////////////////////////////
void main(void)
{
Init();
//n=-100;
//while(n++<10000)
while(Date_de_intrare())
	{
	 counts=0;
	 fprintf(fileho, "%d\n", n);
	 Cauta_solutiile();
	 if (counts) fprintf(fileho, "%d\n\n", counts);
		else fprintf(fileho, "nu exista perechi (a, b)\n\n");
//	 if (counts)
		printf("Pentru %d au fost %d perechi.\n", n, counts);
	}
Close();
}
